{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FColorPersistent: TCastleColorRGBPersistent;
  function GetColorForPersistent: TCastleColorRGB;
  procedure SetColorForPersistent(const AValue: TCastleColorRGB);
published
  { @link(Color) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(Color) directly.

    @seealso Color }
  property ColorPersistent: TCastleColorRGBPersistent read FColorPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastlePointLight.GetColorForPersistent: TCastleColorRGB;
begin
  Result := Color;
end;

procedure TCastlePointLight.SetColorForPersistent(const AValue: TCastleColorRGB);
begin
  Color := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FColorPersistent := TCastleColorRGBPersistent.Create;
  FColorPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetColorForPersistent;
  FColorPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetColorForPersistent;
  FColorPersistent.InternalDefaultValue := Color; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FColorPersistent);
{$endif read_implementation_destructor}

{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FAttenuationPersistent: TCastleVector3Persistent;
  function GetAttenuationForPersistent: TVector3;
  procedure SetAttenuationForPersistent(const AValue: TVector3);
published
  { @link(Attenuation) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(Attenuation) directly.

    @seealso Attenuation }
  property AttenuationPersistent: TCastleVector3Persistent read FAttenuationPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastlePointLight.GetAttenuationForPersistent: TVector3;
begin
  Result := Attenuation;
end;

procedure TCastlePointLight.SetAttenuationForPersistent(const AValue: TVector3);
begin
  Attenuation := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FAttenuationPersistent := TCastleVector3Persistent.Create;
  FAttenuationPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetAttenuationForPersistent;
  FAttenuationPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetAttenuationForPersistent;
  FAttenuationPersistent.InternalDefaultValue := Attenuation; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FAttenuationPersistent);
{$endif read_implementation_destructor}

