{ -*- buffer-read-only: t -*-

  Copyright 2015-2023 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated node properties.

  Do not edit this file manually!
  To add new properties:
  - add them to the text files in tools/internal/x3d-nodes-to-pascal/nodes-specification/ ,
  - and regenerate include files by running x3d-nodes-to-pascal }

{$ifdef read_interface}

  strict private
    function GetNameField: String;
    procedure SetNameField(const Value: String);
    function GetReference: String;
    procedure SetReference(const Value: String);
  public
    procedure CreateNode; override;
    class function ClassX3DType: string; override;

    strict private FFdName: TSFString;
    { Internal wrapper for property @link(NameField). This wrapper API may change, we advise to access simpler @link(NameField) instead. }
    public property FdName: TSFString read FFdName;
    {  }
    property NameField: String read GetNameField write SetNameField;

    strict private FFdReference: TSFString;
    { Internal wrapper for property @link(Reference). This wrapper API may change, we advise to access simpler @link(Reference) instead. }
    public property FdReference: TSFString read FFdReference;
    {  }
    property Reference: String read GetReference write SetReference;

{$endif read_interface}

{$ifdef read_implementation}

{ TAbstractMetadataNode ----------------------------------------------- }

function TAbstractMetadataNode.GetNameField: String;
begin
  Result := FdName.Value;
end;

procedure TAbstractMetadataNode.SetNameField(const Value: String);
begin
  FdName.Send(Value);
end;

function TAbstractMetadataNode.GetReference: String;
begin
  Result := FdReference.Value;
end;

procedure TAbstractMetadataNode.SetReference(const Value: String);
begin
  FdReference.Send(Value);
end;

class function TAbstractMetadataNode.ClassX3DType: String;
begin
  Result := 'X3DMetadataNode';
end;

procedure TAbstractMetadataNode.CreateNode;
begin
  inherited;

  FFdName := TSFString.Create(Self, True, 'name', '');
   FdName.ChangeAlways := chNone;
  AddField(FFdName);

  FFdReference := TSFString.Create(Self, True, 'reference', '');
   FdReference.ChangeAlways := chNone;
  AddField(FFdReference);

  DefaultContainerField := 'metadata';
end;

{$endif read_implementation}
